package {
	import flash.events.*;
	import flash.display.Sprite;
	import com.fileitup.fisixengine.core.FisixEngine;
	import com.fileitup.fisixengine.collisions.ReactionModes;
	import com.fileitup.fisixengine.core.FisixObject;
	import com.fileitup.fisixengine.core.Vector;
	import com.fileitup.fisixengine.particles.CircleParticle;
	import com.fileitup.fisixengine.surfaces.DynamicSurface;
	import com.fileitup.fisixengine.primitives.Particle;
	import com.fileitup.fisixengine.particles.WheelParticle;
	import com.fileitup.fisixengine.resources.Rope;

	[SWF(width="450", height="400", frameRate="30", backgroundColor="0xEEEEEE")]
	public class Exam_WheelParticle extends Sprite
	{
		private var myEngine:FisixEngine;
		
		public function Exam_WheelParticle()
		{
			//엔진 기본 설정
			myEngine = new FisixEngine();
			myEngine.setReactionMode(ReactionModes.PHYSICAL);
			myEngine.setGravity(0,1);
			myEngine.setRender(true);
			myEngine.setRenderGraphics(graphics);
			this.addEventListener(Event.ENTER_FRAME, on_EnterFrame);
			//아래부터 내용 작성
			this.drawWalls(myEngine);//벽 만들기
			this.drawRails(myEngine);//레일 만들기
			this.stage.addEventListener(MouseEvent.MOUSE_DOWN, on_MouseDown);//파티클 생성
		}
		private function on_EnterFrame(e:Event):void {
			myEngine.mainLoop(1);
		}
		/**
		 * 벽 만들기
		 */
		private function drawWalls(_engine:FisixEngine):void {
			var walls:FisixObject = _engine.newFisixObject();
			var W:Number = this.stage.stageWidth;
			var H:Number = this.stage.stageHeight;
			walls.newSurface(new Vector(0,0),new Vector(W,0),10);
			walls.newSurface(new Vector(W,0),new Vector(W,H),10);
			walls.newSurface(new Vector(W,H),new Vector(0,H),10);
			walls.newSurface(new Vector(0,H),new Vector(0,0),10);
			walls.makeStatic();
		}
		/**
		 * 레일 만들기
		 */
		private function drawRails(_engine:FisixEngine):void {
			var rails:FisixObject = _engine.newFisixObject();
			var ds:DynamicSurface;
			ds = new DynamicSurface(new Particle(110, 50), new Particle(220, 100), 10);//위 왼쪽
			ds.particleA.makeStatic();
			rails.addObject(ds);
			ds = new DynamicSurface(new Particle(330, 50), new Particle(230, 100), 10);//위 오른쪽
			ds.particleA.makeStatic();
			rails.addObject(ds);
			ds = new DynamicSurface(new Particle(130, 140), new Particle(320, 140), 10);//가운데
			ds.makeStatic();
			rails.addObject(ds);
			ds = new DynamicSurface(new Particle(55, 180), new Particle(180, 220), 10);//아래 왼쪽
			ds.makeStatic();
			rails.addObject(ds);
			ds = new DynamicSurface(new Particle(395, 180), new Particle(270, 220), 10);//아래 오른쪽
			ds.makeStatic();
			rails.addObject(ds);
			var rope:Rope = new Rope(new Vector(100, 250), new Vector(350,250), 30, 1, 1, 0, 20);
			rope.head.makeStatic();
			rope.tail.makeStatic();
			rails.addObject(rope);
		}
		/**
		 * 파티클 생성
		 */
		private function on_MouseDown(e:MouseEvent):void {
			var cp:WheelParticle = new WheelParticle(e.localX, e.localY, 20);
			this.myEngine.addObject(cp);
		}
	}
}
